## ninja-build 1.10.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(ninja)

# --- optional link-time optimization
if(CMAKE_BUILD_TYPE MATCHES "Release")
	include(CheckIPOSupported)
	check_ipo_supported(RESULT lto_supported OUTPUT error)

	if(lto_supported)
		message(STATUS "IPO / LTO enabled")
		set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
	else()
		message(STATUS "IPO / LTO not supported: <${error}>")
	endif()
endif()

# --- compiler flags
if(MSVC)
	set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
	string(APPEND CMAKE_CXX_FLAGS " /W4 /GR- /Zc:__cplusplus")
else()
	include(CheckCXXCompilerFlag)
	check_cxx_compiler_flag(-Wno-deprecated flag_no_deprecated)
	if(flag_no_deprecated)
		string(APPEND CMAKE_CXX_FLAGS " -Wno-deprecated")
	endif()
	check_cxx_compiler_flag(-fdiagnostics-color flag_color_diag)
	if(flag_color_diag)
		string(APPEND CMAKE_CXX_FLAGS " -fdiagnostics-color")
	endif()
endif()

# --- optional re2c
find_program(RE2C re2c)
if(RE2C)
	# the depfile parser and ninja lexers are generated using re2c.
	function(re2c IN OUT)
		add_custom_command(DEPENDS ${IN} OUTPUT ${OUT}
			COMMAND ${RE2C} -b -i --no-generation-date -o ${OUT} ${IN}
		)
	endfunction()
	re2c(${PROJECT_SOURCE_DIR}/src/depfile_parser.in.cc ${PROJECT_BINARY_DIR}/depfile_parser.cc)
	re2c(${PROJECT_SOURCE_DIR}/src/lexer.in.cc ${PROJECT_BINARY_DIR}/lexer.cc)
	add_library(libninja-re2c OBJECT ${PROJECT_BINARY_DIR}/depfile_parser.cc ${PROJECT_BINARY_DIR}/lexer.cc)
else()
	message(WARNING "re2c was not found; changes to src/*.in.cc will not affect your build.")
	add_library(libninja-re2c OBJECT src/depfile_parser.cc src/lexer.cc)
endif()
target_include_directories(libninja-re2c PRIVATE src)

# Core source files all build into ninja library.
add_library(libninja OBJECT
	src/build_log.cc
	src/build.cc
	src/clean.cc
	src/clparser.cc
	src/dyndep.cc
	src/dyndep_parser.cc
	src/debug_flags.cc
	src/deps_log.cc
	src/disk_interface.cc
	src/edit_distance.cc
	src/eval_env.cc
	src/graph.cc
	src/graphviz.cc
	src/line_printer.cc
	src/manifest_parser.cc
	src/metrics.cc
	src/parser.cc
	src/state.cc
	src/string_piece_util.cc
	src/util.cc
	src/version.cc
)
if(WIN32)
	target_sources(libninja PRIVATE
		src/subprocess-win32.cc
		src/includes_normalize-win32.cc
		src/msvc_helper-win32.cc
		src/msvc_helper_main-win32.cc
		src/getopt.c
	)
	if(MSVC)
		target_sources(libninja PRIVATE src/minidump-win32.cc)
	endif()
else()
	target_sources(libninja PRIVATE src/subprocess-posix.cc)
endif()

#Fixes GetActiveProcessorCount on MinGW
if(MINGW)
target_compile_definitions(libninja PRIVATE _WIN32_WINNT=0x0601 __USE_MINGW_ANSI_STDIO=1)
endif()

# Main executable is library plus main() function.
add_executable(ninja src/ninja.cc)
target_link_libraries(ninja PRIVATE libninja libninja-re2c)

# Tests all build into ninja_test executable.
add_executable(ninja_test
	src/build_log_test.cc
	src/build_test.cc
	src/clean_test.cc
	src/clparser_test.cc
	src/depfile_parser_test.cc
	src/deps_log_test.cc
	src/disk_interface_test.cc
	src/dyndep_parser_test.cc
	src/edit_distance_test.cc
	src/graph_test.cc
	src/lexer_test.cc
	src/manifest_parser_test.cc
	src/ninja_test.cc
	src/state_test.cc
	src/string_piece_util_test.cc
	src/subprocess_test.cc
	src/test.cc
	src/util_test.cc
)
if(WIN32)
	target_sources(ninja_test PRIVATE src/includes_normalize_test.cc src/msvc_helper_test.cc)
endif()
target_link_libraries(ninja_test PRIVATE libninja libninja-re2c)

foreach(perftest
  build_log_perftest
  canon_perftest
  clparser_perftest
  depfile_parser_perftest
  hash_collision_bench
  manifest_parser_perftest
)
  add_executable(${perftest} src/${perftest}.cc)
  target_link_libraries(${perftest} PRIVATE libninja libninja-re2c)
endforeach()

enable_testing()
add_test(NinjaTest ninja_test)

install(TARGETS ninja DESTINATION bin)

## ninja-build 1.0.0

=== debian/changelog ===
ninja-build (1.0.0-0ubuntu1) raring; urgency=low

  * Upload to Ubuntu
  * In debian/rules hardcode path to binary

 -- Jonathan Riddell <jriddell@ubuntu.com>  Tue, 27 Nov 2012 17:39:03 +0000

ninja-build (1.0.0-1) unstable; urgency=low

  * Initial release. (Closes: #683333)

 -- Gary Kramlich <grim@reaperworld.com>  Mon, 17 Sep 2012 02:06:29 -0500

=== debian/control ===
Source: ninja-build
Section: devel
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Gary Kramlich <grim@reaperworld.com>
Build-Depends: debhelper (>=9), libgtest-dev (>=1.6.0), python, asciidoc, hardening-wrapper, re2c, help2man
Standards-Version: 3.9.3
Homepage: http://martine.github.com/ninja/

Package: ninja-build
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: small build system closest in spirit to Make
 Ninja is yet another build system. It takes as input the interdependencies of
 files (typically source code and output executables) and orchestrates
 building them, quickly.
 .
 Ninja joins a sea of other build systems. Its distinguishing goal is to be
 fast. It is born from the Chromium browser project, which has over 30,000
 source files and whose other build systems can take ten seconds to start
 building after changing one file. Ninja is under a second.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

debian/ninja.1: debian/ninja.1.in
	help2man --include=debian/ninja.1.in --output=debian/ninja.1 --no-info --no-discard-stderr debian/ninja-build/usr/bin/ninja

override_dh_auto_configure:
	./bootstrap.py -- --with-gtest=/usr/src/gtest/

override_dh_auto_build:
	./ninja all
	./ninja manual

override_dh_clean:
	dh_clean
	test -x ninja && ./ninja -t clean || true
	find -type f -iname "*.pyc" | xargs rm -f
	rm -f build.ninja
	rm -rf build
	rm -f debian/ninja.1

override_dh_installman: debian/ninja.1
	dh_installman

=== debian/watch ===
version=3
https://github.com/martine/ninja/tags .*/tarball/v(\d[\d\.]+)

## ninja-build 1.3.4

=== debian/changelog ===
ninja-build (1.3.4-1.2~bpo7+0) wheezy; urgency=medium

  * Backport to Wheezy.

 -- Slávek Banko <slavek.banko@axis.cz>  Wed, 12 May 2021 15:43:11 +0200

ninja-build (1.3.4-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Add gnukfreebsd.patch to fix platform detection on gnukfreebsd 9 and later.
    Thanks to Steven Chamberlain for the patch. (Closes: #717364)

 -- Felix Geyer <fgeyer@debian.org>  Sat, 31 May 2014 10:01:37 +0200

ninja-build (1.3.4-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Properly call doxygen in -indep rule. Closes: #716885

 -- Mathieu Malaterre <malat@debian.org>  Thu, 18 Jul 2013 10:09:48 +0200

ninja-build (1.3.4-1) unstable; urgency=low

  [ Gary Kramlich ]
  * New upstream release
  * Added ninja-build-doc package that contains the doxygen output
    (Closes: 712242)
  * Added a patch (also sent upstream) to make doc/manual.asciidoc's output
    xmllint clean (Closes: 712239)

  [ Mathieu Malaterre ]
  * Add missing B-D-I: doxygen

 -- Gary Kramlich <grim@reaperworld.com>  Sun, 30 Jun 2013 18:30:11 -0500

ninja-build (1.3.3-2) unstable; urgency=low

  * Updated standards-version to 3.9.4
  * Updated the man page for 1.3.3
  * Fixed building on kfreebsd

 -- Gary Kramlich <grim@reaperworld.com>  Sat, 25 May 2013 04:49:56 -0500

ninja-build (1.3.3-1) unstable; urgency=low

  * New upstream release
  * Added a build-depends on docbook-xml (Closes: #709158)

 -- Gary Kramlich <grim@reaperworld.com>  Tue, 21 May 2013 22:09:25 -0500

ninja-build (1.2.0-1) unstable; urgency=low

  * New upstream release
  * Added dependencies on xsltproc and docbook-xsl or docbook-xsl-ns

 -- Gary Kramlich <grim@reaperworld.com>  Sun, 19 May 2013 13:35:48 -0500

ninja-build (1.1.0-1) unstable; urgency=low

  * New upstream release
  * Turned on verbose build flag (Closes: #695670)
  * Install the bash completion and zsh completion scripts
  * Install the vim and emacs syntax files

 -- Gary Kramlich <grim@reaperworld.com>  Sun, 14 Apr 2013 22:00:29 -0500

ninja-build (1.0.0-2) unstable; urgency=low

  * Applied Pino Toscano <pino@debian.org> patch for fixing non Linux builds
    (Closes: #695631)

 -- Gary Kramlich <grim@reaperworld.com>  Mon, 10 Dec 2012 23:20:57 -0600

=== debian/control ===
Source: ninja-build
Section: deps-r14/devel
Priority: optional
Maintainer: Gary Kramlich <grim@reaperworld.com>
Build-Depends: debhelper (>=9), libgtest-dev (>=1.6.0), python, asciidoc,
 hardening-wrapper, re2c, help2man, xsltproc, docbook-xsl | docbook-xsl-ns,
 docbook-xml, doc-base
Build-Depends-Indep: doxygen
Homepage: http://martine.github.com/ninja/
Vcs-Browser: https://bitbucket.org/rw_grim/ninja-build-debian-packaging/src
Vcs-Hg: https://bitbucket.org/rw_grim/ninja-build-debian-packaging
Standards-Version: 3.9.4

Package: ninja-build
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: ninja
Description: small build system closest in spirit to Make
 Ninja is yet another build system. It takes as input the interdependencies of
 files (typically source code and output executables) and orchestrates
 building them, quickly.
 .
 Ninja joins a sea of other build systems. Its distinguishing goal is to be
 fast. It is born from the Chromium browser project, which has over 30,000
 source files and whose other build systems can take ten seconds to start
 building after changing one file. Ninja is under a second.

Package: ninja-build-doc
Architecture: all
Section: deps-r14/doc
Depends: ${misc:Depends}
Description: documentation for ninja-build
 Ninja is yet another build system. It takes as input the interdependencies of
 files (typically source code and output executables) and orchestrates
 building them, quickly.
 .
 Ninja joins a sea of other build systems. Its distinguishing goal is to be
 fast. It is born from the Chromium browser project, which has over 30,000
 source files and whose other build systems can take ten seconds to start
 building after changing one file. Ninja is under a second.
 .
 This package contains the doxygen documentation for ninja.

## ninja-build 1.5.1

=== debian/changelog ===
ninja-build (1.5.1-0.1ubuntu1) xenial; urgency=medium

  * Merge from Debian unstable. (Fixes LP: #1473680)
    Remaining changes:
    - Run the tests at build time

 -- Hans Joachim Desserud <ubuntu@desserud.org>  Sun, 12 Jul 2015 15:04:44 +0200

ninja-build (1.5.1-0.1) experimental; urgency=medium

  [Mickaël Guerin]
  * Non-maintainer upload.
  * New upstream release. Closes: #767813
  * Fixed lintian warnings. Closes: #750585, #750583

  [Jussi Pakkanen]
  * Took Mickaël's packaging changes and got them reviewed
    in mentors and fixed the issues raised.

 -- Jussi Pakkanen <jpakkane@gmail.com>  Wed, 19 Nov 2014 18:27:33 +0200

ninja-build (1.3.4-1.1ubuntu1) utopic; urgency=medium

  * Run the tests at build time

 -- Chris Coulson <chris.coulson@canonical.com>  Tue, 27 May 2014 17:20:55 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: ninja-build
-Section: deps-r14/devel
+Section: devel
 Priority: optional
-Maintainer: Gary Kramlich <grim@reaperworld.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Gary Kramlich <grim@reaperworld.com>
 Build-Depends: debhelper (>=9), libgtest-dev (>=1.6.0), python, asciidoc,
- hardening-wrapper, re2c, help2man, xsltproc, docbook-xsl | docbook-xsl-ns,
- docbook-xml, doc-base
+ re2c, help2man, xsltproc, docbook-xsl | docbook-xsl-ns, docbook-xml,
+ doc-base, graphviz
 Build-Depends-Indep: doxygen
 Homepage: http://martine.github.com/ninja/
 Vcs-Browser: https://bitbucket.org/rw_grim/ninja-build-debian-packaging/src
 Vcs-Hg: https://bitbucket.org/rw_grim/ninja-build-debian-packaging
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 
 Package: ninja-build
 Architecture: any
@@ -27,7 +28,7 @@
 
 Package: ninja-build-doc
 Architecture: all
-Section: deps-r14/doc
+Section: doc
 Depends: ${misc:Depends}
 Description: documentation for ninja-build
  Ninja is yet another build system. It takes as input the interdependencies of

=== debian/rules ===
#!/usr/bin/make -f

.PHONY: debian/ninja.1

%:
	dh $@

debian/ninja.1: debian/ninja.1.in
	help2man --include=$< --output=$@ --no-info --no-discard-stderr ./ninja

override_dh_auto_configure:
	./bootstrap.py -- --with-gtest=/usr/src/gtest/

override_dh_auto_build-arch:
	./ninja -v all
	./ninja -v manual

override_dh_auto_build-indep:
	./ninja -v doxygen

override_dh_clean:
	dh_clean
	test -x ninja && ./ninja -t clean || true
	find -type f -iname "*.pyc" | xargs rm -f
	rm -f doc/doxygen/html/*
	rm -f build.ninja
	rm -rf build

override_dh_auto_test:
	sh -c "ulimit -n 2000 && ./ninja_test"

override_dh_install-arch:
	dh_install
	mv debian/ninja-build/etc/bash_completion.d/bash-completion \
	   debian/ninja-build/etc/bash_completion.d/ninja
	mv debian/ninja-build/usr/share/zsh/functions/Completion/zsh-completion \
	   debian/ninja-build/usr/share/zsh/functions/Completion/_ninja

## ninja-build 1.7.1

=== debian/changelog ===
ninja-build (1.7.1-1~ubuntu16.04.1) xenial-backports; urgency=medium

  * No-change backport to xenial

 -- Iain Lane <iain@orangesquash.org.uk>  Fri, 26 May 2017 11:25:54 +0100

ninja-build (1.7.1-1) unstable; urgency=medium

  * New upstream release. (Closes: #824724)
  * Ignore errors from ulimit -n when running the unit tests.
    - Fixes build on kfreebsd. (Closes: #820012)

 -- Felix Geyer <fgeyer@debian.org>  Sat, 21 May 2016 19:12:46 +0200

ninja-build (1.6.0-1) unstable; urgency=medium

  * New maintainer. (Closes: #810025)
  * Generate man page on every build. (Closes: #776605)
  * Fix value of default parallel level in man page. (Closes: #795747)
  * New upstream release. (Closes: #795748)
  * Clean up unused build-depends.
  * Pass CPPFLAGS to the build.
  * Drop ninja-build-doc package, only useful for developing ninja-build itself.
  * Move bash-completion file to /usr/share/bash-completion/completions/.
  * Run unit tests during the build. (Closes: #797586)
    Thanks to Michael Terry for the patch.

 -- Felix Geyer <fgeyer@debian.org>  Mon, 08 Feb 2016 20:54:01 +0100

ninja-build (1.5.1-0.1) unstable; urgency=medium

  [Mickaël Guerin]
  * Non-maintainer upload.
  * New upstream release. Closes: #767813
  * Fixed lintian warnings. Closes: #750585, #750583

  [Jussi Pakkanen]
  * Took Mickaël's packaging changes and got them reviewed
    in mentors and fixed the issues raised.

 -- Jussi Pakkanen <jpakkane@gmail.com>  Wed, 19 Nov 2014 18:27:33 +0200

=== debian/control ===
Source: ninja-build
Section: devel
Priority: optional
Maintainer: Felix Geyer <fgeyer@debian.org>
Build-Depends: asciidoc,
               debhelper (>= 9),
               docbook-xml,
               docbook-xsl,
               help2man,
               python,
               re2c,
               xsltproc
Homepage: https://ninja-build.org/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/ninja-build.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/ninja-build.git
Standards-Version: 3.9.6

Package: ninja-build
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: ninja
Description: small build system closest in spirit to Make
 Ninja is yet another build system. It takes as input the interdependencies of
 files (typically source code and output executables) and orchestrates
 building them, quickly.
 .
 Ninja joins a sea of other build systems. Its distinguishing goal is to be
 fast. It is born from the Chromium browser project, which has over 30,000
 source files and whose other build systems can take ten seconds to start
 building after changing one file. Ninja is under a second.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS)

%:
	dh $@

override_dh_auto_configure:
	./configure.py --bootstrap --verbose

override_dh_auto_build:
	./ninja -v all
	./ninja -v manual
	help2man --include=debian/ninja.1.in --output=build/ninja.1 --no-info --no-discard-stderr ./ninja
	sed -i 's/\(default=\)[0-9]\+, \(derived from CPUs available\)/\1\2/g' build/ninja.1

override_dh_auto_test:
	# Deliberately ignore errors from ulimit.
	# It allows more tests to run but some archs/buildds have a lower hard limit.
	sh -c "ulimit -n 2000; ./ninja_test"

override_dh_clean:
	dh_clean
	test -x ninja && ./ninja -t clean || true
	find -type f -iname "*.pyc" | xargs rm -f
	rm -f null.o
	rm -f build.ninja
	rm -rf build

override_dh_install-arch:
	dh_install
	mv debian/ninja-build/usr/share/bash-completion/completions/bash-completion \
	   debian/ninja-build/usr/share/bash-completion/completions/ninja
	mv debian/ninja-build/usr/share/zsh/functions/Completion/zsh-completion \
	   debian/ninja-build/usr/share/zsh/functions/Completion/_ninja

## ninja-build 1.7.2

=== debian/changelog ===
ninja-build (1.7.2-1) unstable; urgency=medium

  * New upstream release.
  * Move zsh completion file to /usr/share/zsh/vendor-completions/.
    (Closes: #843575)
  * Add -Wl,--as-needed to LDFLAGS.

 -- Felix Geyer <fgeyer@debian.org>  Fri, 11 Nov 2016 17:20:12 +0100

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 
 export DEB_CFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS)
 export DEB_CXXFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS)
+export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
 
 %:
 	dh $@
@@ -32,6 +33,6 @@
 	dh_install
 	mv debian/ninja-build/usr/share/bash-completion/completions/bash-completion \
 	   debian/ninja-build/usr/share/bash-completion/completions/ninja
-	mv debian/ninja-build/usr/share/zsh/functions/Completion/zsh-completion \
-	   debian/ninja-build/usr/share/zsh/functions/Completion/_ninja
+	mv debian/ninja-build/usr/share/zsh/vendor-completions/zsh-completion \
+	   debian/ninja-build/usr/share/zsh/vendor-completions/_ninja

## ninja-build 1.8.2

=== debian/changelog ===
ninja-build (1.8.2-1) unstable; urgency=medium

  * New upstream release.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 24 Sep 2017 11:06:26 +0200

ninja-build (1.7.2-3) unstable; urgency=medium

  * Fix FTBFS with debhelper >= 10.3.
    - Add empty override targets for dh_auto_install and dh_auto_test.
  * Skip unit tests when DEB_BUILD_OPTIONS=nocheck is set.
  * Add basic autopkgtest.

 -- Felix Geyer <fgeyer@debian.org>  Wed, 28 Jun 2017 00:05:54 +0200

ninja-build (1.7.2-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Mark ninja-build Multi-Arch: foreign (Closes: #859173)

 -- Felix Geyer <fgeyer@debian.org>  Sun, 18 Jun 2017 09:43:26 +0200

=== debian/control ===
--- 
+++ 
@@ -17,6 +17,7 @@
 
 Package: ninja-build
 Architecture: any
+Multi-Arch: foreign
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Conflicts: ninja
 Description: small build system closest in spirit to Make

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,17 @@
 	sed -i 's/\(default=\)[0-9]\+, \(derived from CPUs available\)/\1\2/g' build/ninja.1
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# Deliberately ignore errors from ulimit.
 	# It allows more tests to run but some archs/buildds have a lower hard limit.
 	sh -c "ulimit -n 2000; ./ninja_test"
+endif
+
+override_dh_auto_install:
+	# noop
+
+override_dh_auto_clean:
+	# noop
 
 override_dh_clean:
 	dh_clean

## ninja-build 1.9.0

=== debian/changelog ===
ninja-build (1.9.0-2) unstable; urgency=medium

  * Make build reproducible again. (Closes: #932117)
    - Fix man page sed pattern.
  * Switch to debhelper compat level 12.
  * Add a nodoc build profile.

 -- Felix Geyer <fgeyer@debian.org>  Sat, 27 Jul 2019 10:04:12 +0200

ninja-build (1.9.0-1) unstable; urgency=medium

  * New upstream release. (Closes: #923545)

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org

  [ Felix Geyer ]
  * Drop Conflicts: ninja as that package has been removed.
  * Drop obsolete /etc/bash-completion.d/ninja removal maintscript.

 -- Felix Geyer <fgeyer@debian.org>  Sat, 13 Jul 2019 21:25:34 +0200

=== debian/control ===
Source: ninja-build
Section: devel
Priority: optional
Maintainer: Felix Geyer <fgeyer@debian.org>
Build-Depends: asciidoc <!nodoc>,
               debhelper-compat (= 12),
               docbook-xml <!nodoc>,
               docbook-xsl <!nodoc>,
               help2man <!nodoc>,
               python,
               re2c,
               xsltproc <!nodoc>,
Homepage: https://ninja-build.org/
Vcs-Git: https://salsa.debian.org/debian/ninja-build.git
Vcs-Browser: https://salsa.debian.org/debian/ninja-build
Standards-Version: 3.9.6

Package: ninja-build
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: small build system closest in spirit to Make
 Ninja is yet another build system. It takes as input the interdependencies of
 files (typically source code and output executables) and orchestrates
 building them, quickly.
 .
 Ninja joins a sea of other build systems. Its distinguishing goal is to be
 fast. It is born from the Chromium browser project, which has over 30,000
 source files and whose other build systems can take ten seconds to start
 building after changing one file. Ninja is under a second.

=== debian/rules ===
--- 
+++ 
@@ -12,9 +12,12 @@
 
 override_dh_auto_build:
 	./ninja -v all
+ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
 	./ninja -v manual
-	help2man --include=debian/ninja.1.in --output=build/ninja.1 --no-info --no-discard-stderr ./ninja
-	sed -i 's/\(default=\)[0-9]\+, \(derived from CPUs available\)/\1\2/g' build/ninja.1
+	help2man --include=debian/ninja.1.in --output=build/ninja.1.org --no-info --no-discard-stderr ./ninja
+	sed 's/\(default=\)[0-9]\+ on this system/\1\#CPUs/' build/ninja.1.org > build/ninja.1
+	if cmp --silent build/ninja.1.org build/ninja.1; then echo "sed pattern not found"; exit 1; fi
+endif
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
@@ -43,4 +46,3 @@
 	   debian/ninja-build/usr/share/bash-completion/completions/ninja
 	mv debian/ninja-build/usr/share/zsh/vendor-completions/zsh-completion \
 	   debian/ninja-build/usr/share/zsh/vendor-completions/_ninja
-

## ninja-build 1.10.0

=== debian/changelog ===
ninja-build (1.10.0-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:20:41 +0100

ninja-build (1.10.0-1) unstable; urgency=medium

  * New upstream release.

 -- Felix Geyer <fgeyer@debian.org>  Fri, 31 Jan 2020 23:47:24 +0100

ninja-build (1.9.0-3) unstable; urgency=medium

  * Switch build to python3. (Closes: #937142)
  * Add python3 to Suggests as it's used for 'ninja -t browse'.

 -- Felix Geyer <fgeyer@debian.org>  Fri, 30 Aug 2019 19:28:53 +0200

=== debian/watch ===
version=3
https://github.com/martine/ninja/tags .*/v(\d[\d\.]+)\.tar\.gz

## ninja-build 1.10.1

=== debian/changelog ===
ninja-build (1.10.1-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 08 Jun 2021 14:06:13 -0700

ninja-build (1.10.1-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Philipp Huebner <debalance@debian.org>  Sun, 03 Jan 2021 15:39:58 +0100

ninja-build (1.10.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop use_html.escape_for_python3.patch, applied upstream.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 30 Aug 2020 11:52:09 +0200

ninja-build (1.10.0-2) unstable; urgency=medium

  * Cherry-pick patch to fix ninja -t browse with Python >= 3.8.
    (Closes: 958723)
    - Add use_html.escape_for_python3.patch

 -- Felix Geyer <fgeyer@debian.org>  Sun, 21 Jun 2020 11:09:37 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,17 @@
 Source: ninja-build
 Section: devel
 Priority: optional
-Maintainer: Felix Geyer <fgeyer@debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Felix Geyer <fgeyer@debian.org>
+Uploaders: Philipp Huebner <debalance@debian.org>
 Build-Depends: asciidoc <!nodoc>,
                debhelper-compat (= 12),
                docbook-xml <!nodoc>,
                docbook-xsl <!nodoc>,
                help2man <!nodoc>,
-               python,
+               python3,
                re2c,
-               xsltproc <!nodoc>,
+               xsltproc <!nodoc>
 Homepage: https://ninja-build.org/
 Vcs-Git: https://salsa.debian.org/debian/ninja-build.git
 Vcs-Browser: https://salsa.debian.org/debian/ninja-build
@@ -19,6 +21,7 @@
 Architecture: any
 Multi-Arch: foreign
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Suggests: python3
 Description: small build system closest in spirit to Make
  Ninja is yet another build system. It takes as input the interdependencies of
  files (typically source code and output executables) and orchestrates

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	dh $@
 
 override_dh_auto_configure:
-	./configure.py --bootstrap --verbose
+	python3 ./configure.py --bootstrap --verbose
 
 override_dh_auto_build:
 	./ninja -v all
@@ -46,3 +46,6 @@
 	   debian/ninja-build/usr/share/bash-completion/completions/ninja
 	mv debian/ninja-build/usr/share/zsh/vendor-completions/zsh-completion \
 	   debian/ninja-build/usr/share/zsh/vendor-completions/_ninja
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym

=== debian/tests/control ===
Tests: basic
Depends: build-essential, ninja-build

## ninja-build 1.11.0

=== debian/changelog ===
ninja-build (1.11.0-1) unstable; urgency=medium

  [ Felix Geyer ]
  * New upstream release.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Update watch file format version to 4.
  * Bump debhelper from old 12 to 13.
    + Drop check for DEB_BUILD_OPTIONS containing "nocheck", since debhelper now
      does this.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Felix Geyer <fgeyer@debian.org>  Mon, 23 May 2022 21:56:20 +0200

## ninja-build 1.11.1

=== debian/changelog ===
ninja-build (1.11.1-2) unstable; urgency=medium

  * Support large inode numbers on 32-bit systems. (Closes: #1041897)
    - Cherry-pick upstream commit as support_32bit_system_like_i386.patch

 -- Felix Geyer <fgeyer@debian.org>  Sun, 03 Sep 2023 16:34:04 +0200

ninja-build (1.11.1-1) unstable; urgency=medium

  * New upstream release.

 -- Felix Geyer <fgeyer@debian.org>  Fri, 02 Sep 2022 12:31:31 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,15 @@
 Source: ninja-build
 Section: devel
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Felix Geyer <fgeyer@debian.org>
-Uploaders: Philipp Huebner <debalance@debian.org>
+Maintainer: Felix Geyer <fgeyer@debian.org>
 Build-Depends: asciidoc <!nodoc>,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                docbook-xml <!nodoc>,
                docbook-xsl <!nodoc>,
                help2man <!nodoc>,
                python3,
                re2c,
-               xsltproc <!nodoc>
+               xsltproc <!nodoc>,
 Homepage: https://ninja-build.org/
 Vcs-Git: https://salsa.debian.org/debian/ninja-build.git
 Vcs-Browser: https://salsa.debian.org/debian/ninja-build

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,6 @@
 
 export DEB_CFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS)
 export DEB_CXXFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS)
-export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
 
 %:
 	dh $@
@@ -20,11 +19,9 @@
 endif
 
 override_dh_auto_test:
-ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	# Deliberately ignore errors from ulimit.
 	# It allows more tests to run but some archs/buildds have a lower hard limit.
 	sh -c "ulimit -n 2000; ./ninja_test"
-endif
 
 override_dh_auto_install:
 	# noop
@@ -46,6 +43,3 @@
 	   debian/ninja-build/usr/share/bash-completion/completions/ninja
 	mv debian/ninja-build/usr/share/zsh/vendor-completions/zsh-completion \
 	   debian/ninja-build/usr/share/zsh/vendor-completions/_ninja
-
-override_dh_strip:
-	dh_strip --no-automatic-dbgsym

=== debian/watch ===
version=4
https://github.com/martine/ninja/tags .*/v(\d[\d\.]+)\.tar\.gz

## ninja-build 1.12.1

=== debian/changelog ===
ninja-build (1.12.1-1deepin0) unstable; urgency=medium

  * No source change upload against GCC 12.

 -- Tianyu Chen <sweetyfish@deepin.org>  Fri, 20 Sep 2024 12:14:17 +0800

ninja-build (1.12.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop support_32bit_system_like_i386.patch, applied upstream.
  * Build using cmake instead of using upstream's bootstrapping script.
    It doesn't support building the unit tests anymore.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 12 May 2024 11:17:01 +0200

## ninja-build 1.13.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

include(CheckSymbolExists)
include(CheckIPOSupported)

option(NINJA_BUILD_BINARY "Build ninja binary" ON)
option(NINJA_FORCE_PSELECT "Use pselect() even on platforms that provide ppoll()" OFF)

project(ninja CXX)

# --- optional link-time optimization
check_ipo_supported(RESULT lto_supported OUTPUT error)

if(lto_supported)
	message(STATUS "IPO / LTO enabled")
	set(CMAKE_POLICY_DEFAULT_CMP0069 NEW)
	set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELEASE TRUE)
else()
	message(STATUS "IPO / LTO not supported: <${error}>")
endif()

# --- compiler flags
if(MSVC)
	set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
	string(REPLACE "/GR" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
	# Note that these settings are separately specified in configure.py, and
	# these lists should be kept in sync.
	add_compile_options(/W4 /wd4100 /wd4267 /wd4706 /wd4702 /wd4244 /GR- /Zc:__cplusplus)
	add_compile_definitions(_CRT_SECURE_NO_WARNINGS)
else()
	include(CheckCXXCompilerFlag)
	check_cxx_compiler_flag(-Wno-deprecated flag_no_deprecated)
	if(flag_no_deprecated)
		add_compile_options(-Wno-deprecated)
	endif()
	if(CMAKE_VERSION VERSION_LESS 3.24)
		check_cxx_compiler_flag(-fdiagnostics-color flag_color_diag)
		if(flag_color_diag)
			add_compile_options(-fdiagnostics-color)
		endif()
	elseif(NOT DEFINED ENV{CMAKE_COLOR_DIAGNOSTICS})
		set(CMAKE_COLOR_DIAGNOSTICS ON)
	endif()

	if(NOT NINJA_FORCE_PSELECT)
		# Check whether ppoll() is usable on the target platform.
		# Set -DUSE_PPOLL=1 if this is the case.
		#
		# NOTE: Use check_cxx_symbol_exists() instead of check_symbol_exists()
		# because on Linux, <poll.h> only exposes the symbol when _GNU_SOURCE
		# is defined.
		#
		# Both g++ and clang++ define the symbol by default, because the C++
		# standard library headers require it, but *not* gcc and clang, which
		# are used by check_symbol_exists().
		include(CheckCXXSymbolExists)
		check_cxx_symbol_exists(ppoll poll.h HAVE_PPOLL)
		if(HAVE_PPOLL)
			add_compile_definitions(USE_PPOLL=1)
		endif()
	endif()
endif()

# --- optional re2c
set(RE2C_MAJOR_VERSION 0)
find_program(RE2C re2c)
if(RE2C)
	execute_process(COMMAND "${RE2C}" --vernum OUTPUT_VARIABLE RE2C_RAW_VERSION)
	math(EXPR RE2C_MAJOR_VERSION "${RE2C_RAW_VERSION} / 10000")
endif()
if(${RE2C_MAJOR_VERSION} GREATER 1)
	# the depfile parser and ninja lexers are generated using re2c.
	function(re2c IN OUT)
		add_custom_command(DEPENDS ${IN} OUTPUT ${OUT}
			COMMAND ${RE2C} -b -i --no-generation-date --no-version -o ${OUT} ${IN}
		)
	endfunction()
	re2c(${PROJECT_SOURCE_DIR}/src/depfile_parser.in.cc ${PROJECT_BINARY_DIR}/depfile_parser.cc)
	re2c(${PROJECT_SOURCE_DIR}/src/lexer.in.cc ${PROJECT_BINARY_DIR}/lexer.cc)
	add_library(libninja-re2c OBJECT ${PROJECT_BINARY_DIR}/depfile_parser.cc ${PROJECT_BINARY_DIR}/lexer.cc)
else()
	message(WARNING "re2c 2 or later was not found; changes to src/*.in.cc will not affect your build.")
	add_library(libninja-re2c OBJECT src/depfile_parser.cc src/lexer.cc)
endif()
target_include_directories(libninja-re2c PRIVATE src)

# --- Check for 'browse' mode support
function(check_platform_supports_browse_mode RESULT)
	# Make sure the inline.sh script works on this platform.
	# It uses the shell commands such as 'od', which may not be available.

	execute_process(
		COMMAND sh -c "echo 'TEST' | src/inline.sh var"
		WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
		RESULT_VARIABLE inline_result
		OUTPUT_QUIET
		ERROR_QUIET
	)
	if(NOT inline_result EQUAL "0")
		# The inline script failed, so browse mode is not supported.
		set(${RESULT} "0" PARENT_SCOPE)
		if(NOT WIN32)
			message(WARNING "browse feature omitted due to inline script failure")
		endif()
		return()
	endif()

	# Now check availability of the unistd header
	check_symbol_exists(fork "unistd.h" HAVE_FORK)
	check_symbol_exists(pipe "unistd.h" HAVE_PIPE)
	set(browse_supported 0)
	if (HAVE_FORK AND HAVE_PIPE)
		set(browse_supported 1)
	endif ()
	set(${RESULT} "${browse_supported}" PARENT_SCOPE)
	if(NOT browse_supported)
		message(WARNING "browse feature omitted due to missing `fork` and `pipe` functions")
	endif()

endfunction()

set(NINJA_PYTHON "python" CACHE STRING "Python interpreter to use for the browse tool")

check_platform_supports_browse_mode(platform_supports_ninja_browse)

# Core source files all build into ninja library.
add_library(libninja OBJECT
	src/build_log.cc
	src/build.cc
	src/clean.cc
	src/clparser.cc
	src/dyndep.cc
	src/dyndep_parser.cc
	src/debug_flags.cc
	src/deps_log.cc
	src/disk_interface.cc
	src/edit_distance.cc
	src/elide_middle.cc
	src/eval_env.cc
	src/graph.cc
	src/graphviz.cc
	src/jobserver.cc
	src/json.cc
	src/line_printer.cc
	src/manifest_parser.cc
	src/metrics.cc
	src/missing_deps.cc
	src/parser.cc
	src/real_command_runner.cc
	src/state.cc
	src/status_printer.cc
	src/string_piece_util.cc
	src/util.cc
	src/version.cc
)
if(WIN32)
	target_sources(libninja PRIVATE
		src/subprocess-win32.cc
		src/includes_normalize-win32.cc
		src/jobserver-win32.cc
		src/msvc_helper-win32.cc
		src/msvc_helper_main-win32.cc
		src/getopt.c
		src/minidump-win32.cc
	)
	# Build getopt.c, which can be compiled as either C or C++, as C++
	# so that build environments which lack a C compiler, but have a C++
	# compiler may build ninja.
	set_source_files_properties(src/getopt.c PROPERTIES LANGUAGE CXX)

	# windows.h defines min() and max() which conflict with std::min()
	# and std::max(), which both might be used in sources. Avoid compile
	# errors by telling windows.h to not define those two.
	add_compile_definitions(NOMINMAX)
else()
	target_sources(libninja PRIVATE
		src/jobserver-posix.cc
		src/subprocess-posix.cc
	)
	if(CMAKE_SYSTEM_NAME STREQUAL "OS400" OR CMAKE_SYSTEM_NAME STREQUAL "AIX")
		target_sources(libninja PRIVATE src/getopt.c)
		# Build getopt.c, which can be compiled as either C or C++, as C++
		# so that build environments which lack a C compiler, but have a C++
		# compiler may build ninja.
		set_source_files_properties(src/getopt.c PROPERTIES LANGUAGE CXX)
	endif()

	# Needed for perfstat_cpu_total
	if(CMAKE_SYSTEM_NAME STREQUAL "AIX")
		target_link_libraries(libninja PUBLIC "-lperfstat")
	endif()
endif()

target_compile_features(libninja PUBLIC cxx_std_11)
target_compile_features(libninja-re2c PUBLIC cxx_std_11)

#Fixes GetActiveProcessorCount on MinGW
if(MINGW)
target_compile_definitions(libninja PRIVATE _WIN32_WINNT=0x0601 __USE_MINGW_ANSI_STDIO=1)
endif()

# On IBM i (identified as "OS400" for compatibility reasons) and AIX, this fixes missing
# PRId64 (and others) at compile time in C++ sources
if(CMAKE_SYSTEM_NAME STREQUAL "OS400" OR CMAKE_SYSTEM_NAME STREQUAL "AIX")
	add_compile_definitions(__STDC_FORMAT_MACROS)
endif()

# Main executable is library plus main() function.
if(NINJA_BUILD_BINARY)
	add_executable(ninja src/ninja.cc)
	target_link_libraries(ninja PRIVATE libninja libninja-re2c)

	if(WIN32)
		target_sources(ninja PRIVATE windows/ninja.manifest)
	endif()

	option(NINJA_CLANG_TIDY "Run clang-tidy on source files" OFF)
	if(NINJA_CLANG_TIDY)
		set_target_properties(libninja PROPERTIES CXX_CLANG_TIDY "clang-tidy;--use-color")
		set_target_properties(ninja    PROPERTIES CXX_CLANG_TIDY "clang-tidy;--use-color")
	endif()
endif()

# Adds browse mode into the ninja binary if it's supported by the host platform.
if(platform_supports_ninja_browse)
	# Inlines src/browse.py into the browse_py.h header, so that it can be included
	# by src/browse.cc
	add_custom_command(
		OUTPUT build/browse_py.h
		MAIN_DEPENDENCY src/browse.py
		DEPENDS src/inline.sh
		COMMAND ${CMAKE_COMMAND} -E make_directory ${PROJECT_BINARY_DIR}/build
		COMMAND src/inline.sh kBrowsePy
						< src/browse.py
						> ${PROJECT_BINARY_DIR}/build/browse_py.h
		WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
		VERBATIM
	)

	if(NINJA_BUILD_BINARY)
		target_compile_definitions(ninja PRIVATE NINJA_HAVE_BROWSE)
		target_sources(ninja PRIVATE src/browse.cc)
	endif()
	set_source_files_properties(src/browse.cc
		PROPERTIES
			OBJECT_DEPENDS "${PROJECT_BINARY_DIR}/build/browse_py.h"
			INCLUDE_DIRECTORIES "${PROJECT_BINARY_DIR}"
			COMPILE_DEFINITIONS NINJA_PYTHON="${NINJA_PYTHON}"
	)
endif()

include(CTest)
if(BUILD_TESTING)

  # Can be removed if cmake min version is >=3.24
  if (POLICY CMP0135)
    cmake_policy(SET CMP0135 NEW)
  endif()

  find_package(GTest)
  if(NOT GTest_FOUND)
    include(FetchContent)
    FetchContent_Declare(
      googletest
      # GoogleTest v1.17.0 requires at least C++17 and cmake 3.16 which are above ninja project minimum requirements.
      # GoogleTest v1.16.0 requires at least C++14 and cmake 3.13 which are within the ninja project minimum requirements.
      URL https://github.com/google/googletest/releases/download/v1.16.0/googletest-1.16.0.tar.gz
      URL_HASH SHA256=78c676fc63881529bf97bf9d45948d905a66833fbfa5318ea2cd7478cb98f399
    )
    FetchContent_MakeAvailable(googletest)
  endif()

  # Tests all build into ninja_test executable.
  add_executable(ninja_test
    src/build_log_test.cc
    src/build_test.cc
    src/clean_test.cc
    src/clparser_test.cc
    src/depfile_parser_test.cc
    src/deps_log_test.cc
    src/disk_interface_test.cc
    src/dyndep_parser_test.cc
    src/edit_distance_test.cc
    src/elide_middle_test.cc
    src/explanations_test.cc
    src/graph_test.cc
    src/jobserver_test.cc
    src/json_test.cc
    src/lexer_test.cc
    src/manifest_parser_test.cc
    src/missing_deps_test.cc
    src/ninja_test.cc
    src/state_test.cc
    src/string_piece_util_test.cc
    src/subprocess_test.cc
    src/test.cc
    src/util_test.cc
  )
  if(WIN32)
    target_sources(ninja_test PRIVATE src/includes_normalize_test.cc src/msvc_helper_test.cc
      windows/ninja.manifest)

    if(MSVC)
      # Silence warnings about using unlink rather than _unlink
      target_compile_definitions(ninja_test PRIVATE _CRT_NONSTDC_NO_DEPRECATE)
    endif()
  endif()
  find_package(Threads REQUIRED)
  target_link_libraries(ninja_test PRIVATE libninja libninja-re2c GTest::gtest Threads::Threads)

  foreach(perftest
    build_log_perftest
    canon_perftest
    clparser_perftest
    depfile_parser_perftest
    elide_middle_perftest
    hash_collision_bench
    manifest_parser_perftest
  )
    add_executable(${perftest} src/${perftest}.cc)
    target_link_libraries(${perftest} PRIVATE libninja libninja-re2c)
  endforeach()

  if(CMAKE_SYSTEM_NAME STREQUAL "AIX" AND CMAKE_SIZEOF_VOID_P EQUAL 4)
    # These tests require more memory than will fit in the standard AIX shared stack/heap (256M)
    target_link_options(hash_collision_bench PRIVATE "-Wl,-bmaxdata:0x80000000")
    target_link_options(manifest_parser_perftest PRIVATE "-Wl,-bmaxdata:0x80000000")
  endif()

  add_test(NAME NinjaTest COMMAND ninja_test)
endif()

if(NINJA_BUILD_BINARY)
	install(TARGETS ninja)
endif()

=== debian/changelog ===
ninja-build (1.13.1-1) unstable; urgency=medium

  * New upstream release. (Closes: #1119984)
  * Drop Emacs file as it was moved to a separate project.
  * Cherry-pick upstream commit to fix tests on big endian architectures.
    - Add deps_log_test_support_big_endian_architectures.patch

 -- Felix Geyer <fgeyer@debian.org>  Tue, 04 Nov 2025 22:37:15 +0100

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,13 @@
 Priority: optional
 Maintainer: Felix Geyer <fgeyer@debian.org>
 Build-Depends: asciidoc <!nodoc>,
+               cmake,
                debhelper-compat (= 13),
                docbook-xml <!nodoc>,
                docbook-xsl <!nodoc>,
                help2man <!nodoc>,
-               python3,
+               libgtest-dev <!nocheck>,
+               python3 <!nodoc>,
                re2c,
                xsltproc <!nodoc>,
 Homepage: https://ninja-build.org/

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --builddirectory=build

override_dh_auto_configure:
	# upstream enables LTO only for the "Release" build type but Debian
	# uses the custom "None" type, so enable LTO here for all types
	dh_auto_configure -- -DCMAKE_INTERPROCEDURAL_OPTIMIZATION=ON -DNINJA_PYTHON=python3

ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
execute_after_dh_auto_build:
	# create build.ninja file with the "manual" target
	./configure.py
	build/ninja -v manual
	help2man --include=debian/ninja.1.in --output=build/ninja.1.org --no-info --no-discard-stderr build/ninja
	sed 's/\(default=\)[0-9]\+ on this system/\1\#CPUs/' build/ninja.1.org > build/ninja.1
	if cmp --silent build/ninja.1.org build/ninja.1; then echo "sed pattern not found"; exit 1; fi
endif

override_dh_auto_test:
	# Deliberately ignore errors from ulimit.
	# It allows more tests to run but some archs/buildds have a lower hard limit.
	sh -c "ulimit -n 2000; build/ninja_test"

override_dh_install-arch:
	dh_install
	mv debian/ninja-build/usr/share/bash-completion/completions/bash-completion \
	   debian/ninja-build/usr/share/bash-completion/completions/ninja
	mv debian/ninja-build/usr/share/zsh/vendor-completions/zsh-completion \
	   debian/ninja-build/usr/share/zsh/vendor-completions/_ninja

=== debian/tests/control ===
Tests: basic
Depends: ninja-build, build-essential

=== debian/watch ===
version=4
https://github.com/ninja-build/ninja/tags .*/v(\d[\d\.]+)\.tar\.gz

## ninja-build 1.13.2

=== debian/changelog ===
ninja-build (1.13.2-1) unstable; urgency=medium

  * New upstream release.

 -- Felix Geyer <fgeyer@debian.org>  Thu, 20 Nov 2025 17:58:03 +0100
